## $Id: browser.py 12816 2015-03-23 16:47:58Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Views for mandates.
"""
import grok
from urllib import urlencode
from waeup.ikoba.browser.layout import UtilityView
from waeup.ikoba.interfaces import ICompany
from waeup.ikoba.interfaces import MessageFactory as _

class MandateView(UtilityView, grok.View):
    """View to execute mandate.
    """
    grok.context(ICompany)
    grok.name('mandate')
    grok.require('waeup.Public')

    def update(self, *args, **kw):
        form = self.request.form
        mandate_id = form.get('mandate_id', None)
        if not mandate_id:
            self.flash(_('Misuse'))
            return
        mandates = grok.getSite()['mandates']
        mandate = mandates.get(mandate_id, None)
        if mandate is None:
            self.flash(_('No mandate.'))
            return
        msg = mandate.execute()
        self.mandate_name = mandate.__class__.__name__
        self.flash(msg)
        return

    def render(self):
        args = {'camefrom': self.mandate_name}
        self.redirect(self.url(self.context) + '/login?%s' % urlencode(args))
        return
